<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\OrderAdditionalData\Model;

use Lengow\Connector\Model\Import\Order;
use Magento\Framework\DataObject;
use Magento\Framework\Module\Manager;
use Magento\Framework\ObjectManagerInterface;

class LengowOrderFactory
{
    /**
     * @var Manager
     */
    protected $moduleManager;
    /**
     * @var ObjectManagerInterface
     */
    protected $objectManager;

    /**
     * LengowOrderFactory constructor.
     * @param Manager $moduleManager
     * @param ObjectManagerInterface $objectManager
     */
    public function __construct(
        Manager $moduleManager,
        ObjectManagerInterface $objectManager
    ) {
        $this->moduleManager = $moduleManager;
        $this->objectManager = $objectManager;
    }

    /**
     * @param array $data
     * @return mixed
     */
    public function create(array $data = [])
    {
        if ($this->moduleManager->isEnabled('Lengow_Connector')) {
            $instanceName = Order::class;
        } else {
            $instanceName = DataObject::class;
        }
        return $this->objectManager->create($instanceName, $data);
    }
}
