<?php
/**
 *
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace FiloBlu\OrderAdditionalData\Model\Plugin;

use Magento\Sales\Api\Data\ShipmentInterface;
use Magento\Sales\Api\OrderRepositoryInterface;
use Magento\Sales\Api\ShipmentRepositoryInterface;

/**
 * Class ShipmentSave
 * Add Order Increment ID to Shipment
 * @package FiloBlu\OrderAdditionalData\Model\Plugin
 */
class ShipmentSave
{

    /**
     * @var OrderRepositoryInterface
     */
    protected $orderRepository;


    /**
     * ShipmentSave constructor.
     * @param OrderRepositoryInterface $orderRepository
     */
    public function __construct(OrderRepositoryInterface $orderRepository)
    {
        $this->orderRepository = $orderRepository;
    }

    /**
     * @param ShipmentRepositoryInterface $subject
     * @param ShipmentInterface $shipment
     * @return array
     */
    public function beforeSave(ShipmentRepositoryInterface $subject, ShipmentInterface $shipment)
    {
        $order_increment_id = $shipment->getData('order_increment_id');

        if ($order_increment_id == null) {
            $order = $this->orderRepository->get($shipment->getOrderId());
            $shipment->setData('order_increment_id', $order->getIncrementId());
        }

        return [$shipment];
    }
}
